require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Artifact.
    module Artifact
      # @see Artifact#create
      class ArtifactCreate < UU::OS::REST::DTO

        # @see Artifact#create
        attr_accessor :code

        # @see Artifact#create
        attr_accessor :competent_role_uri

        # @see Artifact#create
        attr_accessor :description

        # @see Artifact#create
        attr_accessor :icon_uri

        # @see Artifact#create
        attr_accessor :meta_artifact_uri

        # @see Artifact#create
        attr_accessor :name

        # @see Artifact#create
        attr_accessor :security_level

        # @see Artifact#create
        attr_accessor :create_workflow_async
        
        # @see Artifact#create
        attr_accessor :dry_run
        
        # @see Artifact#create
        attr_accessor :component_content

        # @deprecated Input value is ignored, nil is always assumed.
        attr_accessor :artifact_type

        # @deprecated Always returns nil.
        def artifact_type
          nil
        end

        # @deprecated Input value is ignored, nil is always assumed.
        def artifact_type=(val)
        end
        
        def code 
          attributes[:code]
        end

        def code=(val) 
          attributes[:code] = val
        end

        def competent_role_uri 
          attributes[:competentRoleUri]
        end

        def competent_role_uri=(val) 
          if val
            attributes[:competentRoleUri] = UU::OS::UESURI.new(val)
          else
            attributes[:competentRoleUri] = nil
          end
        end

        def description 
          attributes[:description]
        end

        def  description=(val) 
          attributes[:description] = val
        end

        def  icon_uri 
          attributes[:iconUri]
        end

        def icon_uri=(val) 
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        def meta_artifact_uri 
          attributes[:metaArtifactUri]
        end

        def  meta_artifact_uri=(val) 
          if val
            attributes[:metaArtifactUri] = UU::OS::UESURI.new(val)
          else
            attributes[:metaArtifactUri] = nil
          end
        end

        def  name 
          attributes[:name]
        end

        def  name=(val) 
          attributes[:name] = val
        end

        def  security_level 
          attributes[:securityLevel]
        end

        def security_level=(val) 
          attributes[:securityLevel] = val
        end

        def create_workflow_async
          attributes[:createWorkflowAsync]
        end

        def create_workflow_async=(val) 
          attributes[:createWorkflowAsync] = val
        end
        
        def dry_run
          attributes[:dryRun]
        end

        def dry_run=(val) 
          attributes[:dryRun] = val
        end
        
        def component_content
          attributes[:componentContent]
        end
 
        def component_content=(val) 
          attributes[:componentContent] = val
        end
      end
    end
  end
end
