require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Attachment.
    module Attachment
      class AttachmentVersionAttributes < UU::OS::REST::DTO

        # Id of the attachment version.
        attr_accessor :version_id

        # Code of the attachment version. 
        attr_accessor :code
        
        # Name of the attachment version. 
        attr_accessor :name
        
        # Version number of the attachment version.
        attr_accessor :version

        # UESURI of the attachment.
        attr_accessor :attachment_uri

        # Label of the attachment version.
        attr_accessor :label

        # Creation time of the attachment version.
        attr_accessor :creation_time

        # Creation stamp of the attachment version.
        attr_accessor :creation_stamp
        
        def version_id 
          attributes[:versionId]
        end

        def version_id=(val) 
          attributes[:versionId] = val
        end

        def code 
          attributes[:code]
        end

        def code=(val) 
          attributes[:code] = val
        end
        
        def name 
          attributes[:name]
        end

        def name=(val) 
          attributes[:name] = val
        end
              
        def version 
          attributes[:version]
        end

        def version=(val) 
          attributes[:version] = val
        end
        
        def attachment_uri 
          attributes[:attachmentUri]
        end

        def attachment_uri=(val) 
          if val
            attributes[:attachmentUri] = UU::OS::UESURI.new(val)
          else
            attributes[:attachmentUri] = nil
          end
        end

        def label 
          attributes[:label]
        end

        def label=(val) 
          attributes[:label] = val
        end

        def creation_time 
          attributes[:creationTime]
        end

        def creation_time=(val) 
          attributes[:creationTime] = val
        end

        def creation_stamp 
          attributes[:creationStamp]
        end

        def creation_stamp=(val) 
          attributes[:creationStamp] = val
        end

      end
    end
  end
end
