require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS

    module OrganizationalUnit
      class OrganizationalUnitEntryAttributes < UU::OS::REST::DTO

        # Code of the entry.
        attr_accessor :code

        # Name of the entry.
        attr_accessor :name

        # Description of the entry.
        attr_accessor :description

        # UESURI of the entry.
        attr_accessor :uri

        # Type of the entry.
        #
        # @see UU::OS::OrganizationalUnit::OrganizationalUnitEntryType
        attr_accessor :type

        # UESURI of the entity type of the entry. Never nil.
        attr_accessor :entity_type_uri
        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def uri
          attributes[:uri]
        end

        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def type
          attributes[:type]
        end

        def type=(val)
          attributes[:type] = val
        end

        def entity_type_uri
          attributes[:entityTypeUri]
        end

        def entity_type_uri=(val)
          if val
            attributes[:entityTypeUri] = UU::OS::UESURI.new(val)
          else
            attributes[:entityTypeUri] = nil
          end
        end

      end
    end

  end

end
