require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Permission.
    module Permission
      # @see Permission#authorize
      class PermissionAuthorizeResult < UU::OS::REST::DTO

        # URI of the user's role which is authorized to run specified use case over the specified entity.
        attr_accessor :executive_role_uri
        
        # Normalized uri of the specified entity.
        attr_accessor :uri
        
        def executive_role_uri
          attributes[:executiveRoleUri]
        end

        def executive_role_uri=(val)
          if val
            attributes[:executiveRoleUri] = UU::OS::UESURI.new(val)
          else
            attributes[:executiveRoleUri] = nil
          end
        end
        
        def uri
          attributes[:uri]
        end
        
        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

      end
    end

  end
end