require 'uu/os/rest/dto'

module UU
  module OS
    module Sheet
      class SheetGetSheetData < UU::OS::REST::DTO

        # The content type of the artifact. When null is set, the <code>UXML</code> is used.
        # @see UU::OS::Sheet::MimeType
        attr_accessor :requested_mime_type
        
        #@private
        # A flag that indicates whether the instance is mutable or not.
        attr_accessor :immutable
        
        def requested_mime_type 
          attributes[:requestedMimeType]
        end

        def requested_mime_type=(val) 
          attributes[:requestedMimeType] = val
        end
        
        def immutable 
          attributes[:immutable]
        end

        def immutable=(val) 
          attributes[:immutable] = val
        end

      end
    end

  end
end
