require 'uu/os/rest/dto'

module UU
  module OS
    module Sheet
      class SheetSetAttributes < UU::OS::REST::DTO

        # The new name of the sheet. When null is set, the name is not modified. The name must
        # be unique in a given artifact, otherwise the setAttributescommand fails.
        attr_accessor :name

        # The new code of the sheet. When null is set, the code is not modified. The code must
        # be unique in a given artifact, otherwise the setAttributescommand fails.
        attr_accessor :code

        # Specifies if the sheet is set as the main sheet of the specified artifact. When null
        # is set, the main is not modified. When true is set, the sheet mustbe visible. When
        # false is set and the sheet is set as the main sheet of the specified artifact, system
        # sets first one the visible sheet as the main sheet of the specified artifact.  If
        # the main sheet of the specified artifact is simultaneously the first visible sheet,
        # nothing happens.
        attr_accessor :main

        # Specifies if the sheet is set as visible sheet of the specified artifact. When null
        # is set, the visible is not modified. When false is set, the sheetmust not be set as
        # the main of the specified artifact.
        attr_accessor :visible

        # Specifies the order (or index) of the sheet in the specified artifact. All sheets
        # in an artifact are ordered sequentially. The first sheet has index 0.When 0 or less
        # is set, the sheet is inserted at the beginning of the sheet list. When null is set,
        # the order is not modified. Sheet currently atthat position (if any) and any subsequent
        # sheets are shifted to the right (adds one to their order).
        attr_accessor :order

        # The new description of the sheet. When null is set, the description is not modified.
        attr_accessor :description

        # The new width of the sheet. When null is set, the width is not modified.
        attr_accessor :width
        
        # Flag indicating if sheet can be edited in visual. Attribute is not modified when null is set.
        attr_accessor :enabled_editing
        
        def name 
          attributes[:name]
        end

        def name=(val) 
          attributes[:name] = val
        end

        def code 
          attributes[:code]
        end

        def code=(val) 
          attributes[:code] = val
        end

        def main 
          attributes[:main]
        end

        def main=(val) 
          attributes[:main] = val
        end

        def visible 
          attributes[:visible]
        end

        def visible=(val) 
          attributes[:visible] = val
        end

        def order 
          attributes[:order]
        end

        def order=(val) 
          attributes[:order] = val
        end

        def description 
          attributes[:description]
        end

        def description=(val) 
          attributes[:description] = val
        end

        def width 
          attributes[:width]
        end

        def width=(val) 
          attributes[:width] = val
        end
        
        def enabled_editing 
          attributes[:enabledEditing]
        end

        def enabled_editing=(val) 
          attributes[:enabledEditing] = val
        end   

      end
    end

  end
end
