require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module UseCase
      # @see UseCase#create
      class UseCaseCreate < UU::OS::REST::DTO

        # @see UseCase#create
        attr_accessor :name

        # @see UseCase#create 
        attr_accessor :code

        # @see UseCase#create
        attr_accessor :description

        # @see UseCase#create
        attr_accessor :use_case_realization_uri

        # @see UseCase#create
        attr_accessor :options
        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def use_case_realization_uri
          attributes[:useCaseRealizationUri]
        end

        def use_case_realization_uri=(val)
          if val
            attributes[:useCaseRealizationUri] = UU::OS::UESURI.new(val)
          else
            attributes[:useCaseRealizationUri] = nil
          end
        end

        def options
          attributes[:options]
        end

        def options=(val)
          if val
            attributes[:options] = UU::OS::REST::BinaryValue.new(val)
          else
            attributes[:options] = nil
          end
        end

      end
    end

  end
end
